<?php

function writeToErrorLog($errorMessage, $sendToEmail = false, $filename = 'common_errors') {
	$errorMessageFull = date('Y.m.d - H:i:s').' - '.$errorMessage.' - '.$_SERVER['SCRIPT_NAME']."\n";
	file_put_contents(SYSTEM_DIR.'/logs/'.$filename.'.log', $errorMessageFull, FILE_APPEND);
	if (DEBUG) {
		echo PHP_EOL."\033[31mError log".($sendToEmail?(' (email)'):'').":\033[37m".PHP_EOL.$errorMessageFull;
	}
	if ($sendToEmail) {
		emailSend(ADMIN_EMAIL, SITE_TITLE_SHORT, ADMIN_EMAIL, 'Alert '.SITE_TITLE_SHORT, $errorMessageFull);
	}
	return true;
}

function emailSend($fromEmail, $fromName, $to, $subject, $message) {
	$subject = '=?utf-8?B?'.base64_encode($subject).'?=';
	$headers  = "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/plain; charset=\"utf-8\"\r\n";
	$headers .= "Date: ".date ( 'Y-m-d (H:i:s)')."\r\n";
	$headers .= "From: =?utf-8?B?".base64_encode($fromName)."?= <{$fromEmail}>\r\n";
	$headers .= "Return-Path: <{$to}>\r\n";
	$headers .= "X-Priority: 3\r\n";
	$headers .= "X-MSMail-Priority: Normal\r\n";
	$headers .= "X-Mailer: ".SITE_TITLE_SHORT." Mailer\r\n";
	if (!mail($to, $subject, $message, $headers)) {
		writeToErrorLog("mail ($to, $subject, $message, ...);", false, 'email_error');
	}
}

function get_data($str) {
	$out = explode(';', $str);

	if (isset($out['0'], $out['1']))
		return array(trim($out['0']), trim($out['1']));
	else
		return array(trim($out['0']), '');
}

function parse_changes($str) {
	preg_match('|<font color="[^"]+">([+-])([\d\.\,\s]+)</font|', $str, $out);
	$num = (int) preg_replace('/\D/', '', $out[2]);
	if ($out[1] == "-")
		$num *= -1;

	return $num;
}