<?php
date_default_timezone_set('Europe/Moscow');
define('TIMESTART', timeMeasure());
define('ROOT_DIR', dirname ( __FILE__));
define('SYSTEM_DIR', ROOT_DIR.'/system');
require SYSTEM_DIR.'/require.php';
require SYSTEM_DIR.'/libs/liru.php';

isAuth();

if (isset($_SERVER['QUERY_STRING']) AND $_SERVER['QUERY_STRING'] === 'data') {
	header('Content-Type: text/plain; charset=utf-8');
	include SYSTEM_DIR.'/data.txt';
	exit();
}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>My LiveInternet statistics</title>
		<link href="i/tablecloth/tablecloth.css" rel="stylesheet" type="text/css" media="screen" />
		<style type="text/css">
			#tbl {
				width:auto;
			}
			#tbl tr td {
				width:200px;
			}
		</style>
		<script type="text/javascript">
			function vis(id) {
				elem = document.getElementById(id);
				if (elem.style.display == 'none')
					elem.style.display = '';
				else
					elem.style.display = 'none';
			}
			function open_mins(link) {
				window.open(link, 'mins', 'width=680,height=480,scrollbars=no,toolbar=no,statusbar=no,location=no,directories=no,status=no,menubar=no');
				return false;
			}
		</script>
	</head>

<body>
	<table border="1" id="tbl">
		<tr>
			<th></th>
			<th>Сайт</th>
			<th>Посетители</th>
			<th>Просмотры</th>
			<th>24 часа</th>
			<th>Просмотров на посетителя</th>
		</tr>

<?php

$liurl = "https://www.liveinternet.ru/stat/";
$data = file(SYSTEM_DIR.'/data.txt');
$obj = new liru;

$index = 0;
$visitors = 0;
$pageviews = 0;
$last24 = 0;
$visitor_changes = 0;
$pageviews_changes = 0;
$stat_array = $sort_numcie = array ();
$curlStat = array(
	'get' => array(),
	'post' => array(),
);


foreach ($data as $line) {
	$res = get_data($line);
	$login = $res[0];
	$pwd = $res[1];

	$res = $obj->login($login,$pwd);
	if ($res) {
		echo $res;
		continue;
	}
	$res = $obj->parse();
	$stat_array[] = $res;
	$sort_numcie[] = (int) preg_replace ( '/\D/', '', $res['last24'] );

}

array_multisort($sort_numcie, SORT_DESC, $stat_array);

foreach ($stat_array as $res) {
	$urlLiRu = $liurl.$res['site_url'].'/';
	$favicon_url = 'http://'.str_replace('peopleflow.biz', 'people-stream.biz', $res['site_url'] ).'/favicon.ico';
	echo '
	<tr>
		<td style="width:50px; text-align:center">
			<a style="text-decoration:none; color:black;" href="javascript:vis(\'stat'.$index.'\')">+</a>
		</td>
		<td>
			<a style="text-decoration:none; color:black;" href="'.$urlLiRu.'searches.html" target="_blank"><img src="'.$favicon_url.'" height="16" width="16" alt="" /> '.$res['login'].'</a>
		</td>
		<td>'.$res['visitors'][0].' <a target="_blank" href="mins_vs.html" onclick=\'javascript:return open_mins("'.$urlLiRu.'mins_vis.html")\'>'.$res['visitors'][1].'</a></td>
		<td>'.$res['pageviews'][0].' <a target="_blank" href="mins.html" onclick=\'javascript:return open_mins("'.$urlLiRu.'mins.html")\'>'.$res['pageviews'][1].'</a></td>
		<td>'.$res['last24'].'</td>
		<td>'.$res['pageviews/visitor'].'</td>
	</tr>
	<tr id="stat'.$index.'" style="display:none"><td colspan="6" style="text-align: center;"><img src="stat/'.$res['site_url'].'.png" alt="" /></td></tr>';

	$index++;

	$pageviews += str_replace(array(',', '.'), '', $res['pageviews'][0]);
	$visitors += str_replace(array(',', '.'), '', $res['visitors'][0]);
	$last24 += str_replace(array(',', '.'), '', $res['last24']);
	$visitor_changes += parse_changes($res['visitors'][1]);
	$pageviews_changes += parse_changes($res['pageviews'][1]);
}

$visitor_changes_str = "<font color=\"".(($visitor_changes >= 0)?"#007700":"#770000")."\">".(($visitor_changes > 0)?'+':'').number_format($visitor_changes)."</font>";
$pageviews_changes_str = "<font color=\"".(($pageviews_changes >= 0)?"#007700":"#770000")."\">".(($pageviews_changes > 0)?'+':'').number_format($pageviews_changes)."</font>";

echo "<tr><td colspan='6'></td></tr><tr><td style=\"width:50px;text-align:center\"></td><td><b>Всего</b></td><td>".number_format($visitors)." <span style='text-decoration:underline;color:blue'>{$visitor_changes_str}</span></td><td>".number_format($pageviews)." <span style='text-decoration:underline;color:blue'>{$pageviews_changes_str}</span></td><td>".number_format($last24)."</td><td>".number_format($pageviews/$visitors, 1, '.','')."</td></tr>\n";

$res = $obj->parse('http://www.liveinternet.ru/stat/ru/mp3/', 'ru/mp3');
$urlLiRu = 'https://www.liveinternet.ru/stat/'.$res['login'].'/';
echo "
	<tr>
		<td colspan='6'></td>
	</tr>
	<tr>
		<td style=\"width:50px;text-align:center\">
			<a style=\"text-decoration:none; color:black;\" href='javascript:vis(\"stat{$index}\")'>+</a>
		</td>
		<td>
			<a style=\"text-decoration:none; color:black;\" href='{$urlLiRu}searches.html' target=\"_blank\">
				<img src='https://www.liveinternet.ru/i/fav-stat.ico' height='16' width='16' alt='{$res['login']}' />
				{$res['login']}
			</a>
		</td>
		<td>
			{$res['visitors'][0]}
			<a target=\"_blank\" href=\"mins_vs.html\" onclick='javascript:return open_mins(\"{$urlLiRu}mins_vis.html\")'>
				{$res['visitors'][1]}
			</a>
		</td>
		<td>
			{$res['pageviews'][0]}
			<a target=\"_blank\" href=\"mins.html\" onclick='javascript:return open_mins(\"{$urlLiRu}mins.html\")'>
				{$res['pageviews'][1]}
			</a>
		</td>
		<td>
			{$res['last24']}
		</td>
		<td>
			{$res['pageviews/visitor']}
		</td>
	</tr>
	<tr id='stat{$index}' style=\"display:none\">
		<td colspan='6' style='text-align:center'>
			<img src='stat/".str_replace ( '/', '_', $res['site_url'] ) .".png' alt='' />
		</td>
	</tr>\n";
?>

	</table>
<br />
<?=date('Y.m.d - H:i:s')?>
<br />
Время выполнения скрипта: <?=round(timeMeasure()-TIMESTART, 6)?><br />
<small>g<?=count($curlStat['get'])?>p<?=count($curlStat['post'])?></small>
<?php /*<pre><?=print_r($curlStat, true)?></pre>*/ ?>

</body>
</html><?php

function timeMeasure() {
	list ( $msec, $sec ) = explode ( chr ( 32 ) , microtime() );
	return ( $sec + $msec );
}

function isAuth() {
	$check = false;
	$cryptPassword = '$1$Wm4.no2.$wrQzrcYdQKKYvcoyf6S9c0'; //5ZTVLFB...
	$hashStr = $cryptPassword;
	$cookieName = md5($_SERVER['DOCUMENT_URI']."\n".$_SERVER['SERVER_ADDR']);
	$cookieHashValid = hash('sha256', $hashStr);
	if (isset($_COOKIE[$cookieName]) AND $_COOKIE[$cookieName] === $cookieHashValid) {
		$check = true;
	} else {
		if (isset($_POST['p']) AND $_POST['p']) {
			$postPassword = trim($_POST['p']);
			if ($postPassword AND crypt($postPassword, $cryptPassword) === $cryptPassword) {
				$check = true;
				$cookieTime = time() + ( 60 * 60 * 24 * 365 * 5 );
				setcookie($cookieName, $cookieHashValid, $cookieTime, pathinfo($_SERVER['DOCUMENT_URI'], PATHINFO_DIRNAME).'/', '', false, true);
			}
		}
	}

	if (!$check) {
		exit('<form action="'.str_replace('index.php', '', $_SERVER['DOCUMENT_URI']).'" method="post"><input name="p" type="password" autofocus size="50" required placeholder="password" /> <input type="submit" value="enter" /></form>');
	}
}