<?php

class CurlObject
{
    private $agent;
    private $header;
    private $cookie;
    private $referer;
    private $location = 0;
    private $proxy;
    private $fields;
    private $timeout = 30;
    private $file_path;
    private $cookie_file;
    private $isheader = 0;

    public function CurlObject($agent = 'Mozilla/6.0 (Windows; U; Windows NT 5.1; ru-RU; rv:1.7.12) Gecko/20050919 Firefox/3.6.7')
    {
        $this->agent = $agent;

        $this->header[] = "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8";
#		$this->header[] = "Accept-Language: ru-ru,ru;q=0.8,en-us;q=0.5,en;q=0.3";
        $this->header[] = "Accept-Language: en-us,en";
        $this->header[] = "Accept-Encoding: deflate";
        $this->header[] = "Accept-Charset: windows-1251,utf-8;q=0.7,*;q=0.7";
        $this->header[] = "Keep-Alive: 115";
        $this->header[] = "Connection: keep-alive";


		$this->cookie_file = dirname(__FILE__)."/cookies.txt";

        if (filter_var(ini_get('open_basedir'), FILTER_VALIDATE_BOOLEAN)
            or filter_var(ini_get('safe_mode'), FILTER_VALIDATE_BOOLEAN)) {
            $this->location = 1;
        }
    }

    /**
     * @param $ch
     * @param int $response
     * @return bool|string
     */
    private function customFollowLoaction($ch, $response = 0)
    {
        $responseInfo = curl_getinfo($ch);

        if ($responseInfo['http_code'] == 200) {
            if ($responseInfo['http_code'] == 301 || $responseInfo['http_code'] == 302) {
                list($this->header) = explode("\r\n\r\n", $response, 2);
                $matches = array();
                preg_match("/(Location:|URI:)[^(\n)]*/", $this->header, $matches);
                $url = trim(str_replace($matches[1], "", $matches[0]));
                $url_parsed = parse_url($url);
                return (isset($url_parsed)) ? geturl($url) : '';
            }

            return false;
        }
    }

    public function get($url)
    {
        global $curlStat;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_COOKIEJAR, $this->cookie_file);
        curl_setopt($ch, CURLOPT_COOKIEFILE, $this->cookie_file);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_REFERER, $this->referer);
        curl_setopt($ch, CURLOPT_HEADER, $this->isheader);

        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $this->location);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_PROXY, $this->proxy);
        curl_setopt($ch, CURLOPT_TIMEOUT, $this->timeout);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//		curl_setopt($ch, CURLOPT_COOKIE, $this->cookies);
        curl_setopt($ch, CURLOPT_USERAGENT, $this->agent);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $this->header);
        $result = curl_exec($ch);

        $this->referer = $url;
        $curlStat['get'][] = $url;

        if($url = $this->customFollowLoaction($ch, $result)){
            $this->get($url);
            curl_close($ch);
        } else{
            curl_close($ch);
            return $result;
        }
    }

    public function post($url, $fields)
    {
        global $curlStat;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_COOKIEJAR, $this->cookie_file);
        curl_setopt($ch, CURLOPT_COOKIEFILE, $this->cookie_file);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_REFERER, $this->referer);
        curl_setopt($ch, CURLOPT_HEADER, $this->isheader);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $this->location);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_PROXY, $this->proxy);
        curl_setopt($ch, CURLOPT_TIMEOUT, $this->timeout);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//		curl_setopt($ch, CURLOPT_COOKIE, $this->cookies);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_USERAGENT, $this->agent);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $this->header);
        $result = curl_exec($ch);
        $this->referer = $url;
        $curlStat['post'][] = $url;
        $this->fields = $fields;

        if($url = $this->customFollowLoaction($ch, $result)){
            $this->post($url, $fields);
            curl_close($ch);
        } else{
            curl_close($ch);
            return $result;
        }
    }

    public function setProxy($proxy)
    {
        $this->proxy = $proxy;
    }

    public function setTimeout($timeout)
    {
        $this->timeout = $timeout;
    }

    public function setReferer($referer)
    {
        $this->referer = $referer;
    }

    public function setLocation($location)
    {
        $this->location = $location;
    }

    public function setCookie($path)
    {
        $this->cookie_file = $path;
    }

    public function setHeader($isheader)
    {
        $this->isheader = $isheader;
    }
}